/**
 * @file ext_int_driver.h
 * @brief External interrupt line driver
 *
 * @section License
 *
 * Copyright (C) 2010-2019 Oryx Embedded SARL. All rights reserved.
 *
 * This file is part of CycloneTCP Eval.
 *
 * This software is provided in source form for a short-term evaluation only. The
 * evaluation license expires 90 days after the date you first download the software.
 *
 * If you plan to use this software in a commercial product, you are required to
 * purchase a commercial license from Oryx Embedded SARL.
 *
 * After the 90-day evaluation period, you agree to either purchase a commercial
 * license or delete all copies of this software. If you wish to extend the
 * evaluation period, you must contact sales@oryx-embedded.com.
 *
 * This evaluation software is provided "as is" without warranty of any kind.
 * Technical support is available as an option during the evaluation period.
 *
 * @author Oryx Embedded SARL (www.oryx-embedded.com)
 * @version 1.9.4
 **/

#ifndef _EXT_INT_DRIVER_H
#define _EXT_INT_DRIVER_H

//External interrupt line driver
extern const ExtIntDriver extIntDriver;

//External interrupt related functions
error_t extIntInit(void);
void extIntEnableIrq(void);
void extIntDisableIrq(void);
void extIntHandler(void);

//Wrapper for the interrupt service routine
void piobIrqWrapper(void);

#endif
